﻿using System.ComponentModel;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Media;

namespace TestLibrary
{
    /// <summary>
    /// 버튼 컨트롤
    /// </summary>
    public class ButtonControl : Button
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region ImageProperty

        /// <summary>
        /// 이미지 의존 속성 입니다.
        /// </summary>
        public static readonly DependencyProperty ImageProperty;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 라우팅 이벤트 인자
        /// </summary>
        private RoutedEventArgs routedEventArgs = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 이미지 - Image

        /// <summary>
        /// 이미지
        /// </summary>
        [Category("ButtonControl")]
        [Description("이미지를 가져오거나 설정합니다.")]
        public ImageSource Image
        {
            get
            {
                return (ImageSource)GetValue(ImageProperty);
            }
            set
            {
                SetValue(ImageProperty, value);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Static

        #region 생성자 - ButtonControl()

        /// <summary>
        /// 생성자
        /// </summary>
        static ButtonControl()
        {
            ImageProperty = UIHelper.RegisterDependencyProperty
            (
                null,
                false,
                false,
                false,
                true,
                null,
                "Image",
                typeof(ImageSource),
                typeof(ButtonControl),
                null
            );

            DefaultStyleKeyProperty.OverrideMetadata(typeof(ButtonControl), new FrameworkPropertyMetadata(typeof(ButtonControl)));
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ButtonControl()

        /// <summary>
        /// 생성자
        /// </summary>
        public ButtonControl()
        {
            this.routedEventArgs = new RoutedEventArgs(ButtonBase.ClickEvent);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 클릭 실행하기 - PerformClick()

        /// <summary>
        /// 클릭 실행하기
        /// </summary>
        public void PerformClick()
        {
            RaiseEvent(this.routedEventArgs);
        }

        #endregion
    }
}